//                           UNCLASSIFIED
/*-------------------------------------------------------------------------
RAYTHEON PROPRIETARY: THIS DOCUMENT CONTAINS DATA OR INFORMATION
PROPRIETARY TO RAYTHEON COMPANY AND IS RESTRICTED TO USE ONLY BY PERSONS
AUTHORIZED BY RAYTHEON COMPANY IN WRITING TO USE IT. DISCLOSURE TO
UNAUTHORIZED PERSONS WOULD LIKELY CAUSE SUBSTANTIAL COMPETITIVE HARM TO
RAYTHEON COMPANY'S BUSINESS POSITION. NEITHER SAID DOCUMENT NOR ITS
CONTENTS SHALL BE FURNISHED OR DISCLOSED TO OR COPIED OR USED BY PERSONS
OUTSIDE RAYTHEON COMPANY WITHOUT THE EXPRESS WRITTEN APPROVAL OF RAYTHEON
COMPANY.

THIS PROPRIETARY NOTICE IS NOT APPLICABLE IF DELIVERED TO THE U.S.
GOVERNMENT.

UNPUBLISHED WORK - COPYRIGHT RAYTHEON COMPANY.
-------------------------------------------------------------------------*/

using System;
using Raytheon.Instruments.GeneralIO;
using System.Collections.Generic;
using Raytheon.Common;
using NLog;
using Pickering.Lxi.Communication;
using Pickering.Lxi.Piplx;
using Pickering.Lxi;
using System.IO;
using System.Reflection;

namespace Raytheon.Instruments
{
   /// <summary>
   /// A class that implements a Pickering DIO card
   /// </summary>
   public class DIOPickering40x : IGeneralIO, IDisposable
   {
      #region PrivateClassMembers
      private string _name;
      private readonly int _pxiCardSlotIndex;
		private SelfTestResult _selfTestResult;
		private State _state;
		private object _syncObj = new Object();
		private PiplxCard _dioCard;
      private int _numChannelPerPort = 8;
      private int _channelStartIndex = 0;
      private int _numInputChannels;
      private int _numOutputChannels;
		private bool _shallWeInitializeOutput = false;

		private Dictionary<string, IODatatypes.DIOChannelInfo> _signalNameToChannelMap = new Dictionary<string, IODatatypes.DIOChannelInfo>();

      /// <summary>
      /// NLog logger
      /// </summary>
      private readonly ILogger _logger;
		/// <summary>
		/// Raytheon configuration
		/// </summary>
		private readonly IConfigurationManager _configurationManager;
		private readonly IConfiguration _configuration;

		#endregion

		#region PrivateClassFunctions

		/// <summary>
		/// The finalizer.
		/// </summary>
		~DIOPickering40x()
		{
			Dispose(false);
		}

		/// <summary>
		/// Dispose of this object.
		/// </summary>
		/// <param name="disposing">True = currently disposing, False = not disposing.</param>
		protected virtual void Dispose(bool disposing)
		{
			try
			{
				if (disposing)
				{
					// nothing to do here
				}
			}
			catch (Exception)
			{
				try
				{
					//ErrorLogger.Instance().Write(err.Message + "\r\n" + err.StackTrace);
				}
				catch (Exception)
				{
					//Do not rethrow. Exception from error logger that has already been garbage collected
				}
			}
		}

		#endregion

		#region PublicClassFunctions

		/// <summary>
		/// DIOPickering40x factory constructor
		/// </summary>
		/// <param name="deviceName"></param>
		/// <param name="configurationManager"></param>
		public DIOPickering40x(string deviceName, IConfigurationManager configurationManager, ILogger logger)
		{
			Name = deviceName;

			_logger = logger;

			_configurationManager = configurationManager;
			_configuration = _configurationManager.GetConfiguration(Name);

         string assemblyFolder = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
         string dioModuleDefPath = _configuration.GetConfigurationValue(deviceName, ConfigXml.DIO_MODULE_DEF_FILEPATH.ToString());

         if (!Path.IsPathRooted(dioModuleDefPath))
            dioModuleDefPath = Path.GetFullPath(Path.Combine(assemblyFolder, dioModuleDefPath));

         IConfigurationFile dioModuleConfig = new ConfigurationFile(dioModuleDefPath);

         Int32.TryParse(dioModuleConfig.ReadValue(Name, ConfigIni.PXI_CARD_SLOT_INDEX.ToString()), out _pxiCardSlotIndex);

			Boolean.TryParse(dioModuleConfig.ReadValue(Name, ConfigIni.SHALL_WE_DRIVE_OUTPUT_UPON_INITIALIZATION.ToString()), out _shallWeInitializeOutput);

         List<string> outputSignalNames = dioModuleConfig.ReadAllKeys($"{Name}.{ConfigIni.OUTPUT_SIGNALS}");
         List<string> intputSignalNames = dioModuleConfig.ReadAllKeys($"{Name}.{ConfigIni.INPUT_SIGNALS}");

         Int32.TryParse(dioModuleConfig.ReadValue(Name, ConfigIni.NUM_CHANNELS_PER_PORT.ToString()), out _numChannelPerPort);
         Int32.TryParse(dioModuleConfig.ReadValue(Name, ConfigIni.CHANNEL_START_INDEX.ToString()), out _channelStartIndex);

         if (!(_channelStartIndex == 0 || _channelStartIndex == 1))
         {
            throw new Exception($"The value for key {ConfigIni.CHANNEL_START_INDEX.ToString()} in section {Name} must be 0 or 1 in {dioModuleDefPath}");
         }

         IODatatypes.DIOChannelInfo info;
         foreach (string signalName in outputSignalNames)
			{
				if (_signalNameToChannelMap.ContainsKey(signalName))
               throw new Exception($"Key {signalName} in section {Name}.{ConfigIni.OUTPUT_SIGNALS} conflicts with the same key defined in another section.");

            string iniLine = dioModuleConfig.ReadValue($"{Name}.{ConfigIni.OUTPUT_SIGNALS}", signalName);
				string[] infoTokens = iniLine.Split('|');
				if (infoTokens.Length != 2)
				{
					throw new Exception($"Key {signalName} in section {Name}.{ConfigIni.OUTPUT_SIGNALS} does not contain 2 tokens");
				}

            info.channelNumber = Convert.ToUInt32(infoTokens[0]);
            info.initialValue = Convert.ToInt32(infoTokens[1]);

				_signalNameToChannelMap[signalName] = info;
         }

         foreach (string signalName in intputSignalNames)
         {
            if (_signalNameToChannelMap.ContainsKey(signalName))
               throw new Exception($"Key {signalName} in section {Name}.{ConfigIni.INPUT_SIGNALS} conflicts with the same key defined in another section.");

            string iniLine = dioModuleConfig.ReadValue($"{Name}.{ConfigIni.INPUT_SIGNALS}", signalName);

            info.channelNumber = Convert.ToUInt32(iniLine);
				info.initialValue = -1;

            _signalNameToChannelMap[signalName] = info;
         }

         _selfTestResult = SelfTestResult.Unknown;
			_state = State.Uninitialized;
		}

      /// <summary>
      /// Initialize the card
      /// </summary>
      public void Initialize()
      {
         lock (_syncObj)
         {
            if (_state == State.Uninitialized)
            {
               PiplxManager manager = new PiplxManager("");

               _dioCard = (PiplxCard)manager.Cards[_pxiCardSlotIndex];

               PiplxCardInfo info = (PiplxCardInfo)_dioCard.Info;

               _numInputChannels = info.InputSubunitsCount * _numChannelPerPort;
               _numOutputChannels = info.OutputSubunitsCount * _numChannelPerPort;

               _dioCard.Open();

					if (_shallWeInitializeOutput)
					{
						foreach (KeyValuePair<string, IODatatypes.DIOChannelInfo> item in _signalNameToChannelMap)
						{
							if (item.Value.initialValue != -1)
							{
								SetBit(item.Key, (IODatatypes.BitState)item.Value.initialValue);
							}
						}
					}

               _state = State.Ready;
            }
            else
            {
               throw new Exception("Expected the state to be Uninitialized, state was: " + _state.ToString() + " on card " + _name);
            }
         }
      }

      /// <summary>
      /// Return list of signal names
      /// </summary>
      public List<string> GetSignalNames()
		{
			return new List<string>(_signalNameToChannelMap.Keys);
      }

      /// <summary>
      /// 
      /// </summary>
      /// <returns></returns>
      public bool ClearErrors()
		{
			throw new NotImplementedException();
		}

		/// <summary>
		/// 
		/// </summary>
		public string DetailedStatus
		{
			get
			{
				return "This is a Pickering DIO Card " + _name;
			}
		}

		/// <summary>
		/// 
		/// </summary>
		public bool DisplayEnabled
		{
			get
			{
				throw new NotImplementedException();
			}

			set
			{
				throw new NotImplementedException();
			}
		}

		/// <summary>
		/// Dispose of this object.
		/// </summary>
		public void Dispose()
		{
			lock (_syncObj)
			{
				try
				{
					Dispose(true);

					GC.SuppressFinalize(this);
				}
				catch (Exception)
				{
					try
					{
						//ErrorLogger.Instance().Write(err.Message + "\r\n" + err.StackTrace);
					}
					catch (Exception)
					{
						//Do not rethrow. Exception from error logger that has already been garbage collected.
					}
				}
			}
		}

		/// <summary>
		/// 
		/// </summary>
		public bool FrontPanelEnabled
		{
			get
			{
				throw new NotImplementedException();
			}

			set
			{
				throw new NotImplementedException();
			}
		}

      /// <summary>
      /// 
      /// </summary>
      /// <param name="signalName"></param>
      /// <param name="state"></param>
      public void SetBit(string signalName, IODatatypes.BitState state)
      {
         lock (_syncObj)
         {
            if (!_signalNameToChannelMap.ContainsKey(signalName))
               throw new Exception($"Signal name {signalName} doesn't exist for card: " + _name);

            if (_signalNameToChannelMap[signalName].channelNumber >= _numOutputChannels || _signalNameToChannelMap[signalName].channelNumber < _channelStartIndex)
            {
               throw new Exception($"The input channel number {_signalNameToChannelMap[signalName].channelNumber} specified must be >= {_channelStartIndex} and < {_numOutputChannels +_channelStartIndex} on card " + _name);
            }

            GetPortIndexAndBitIndex(signalName, out int portIndex, out int bitIndex);

            DigitalInputOutputSubunit subunit = (DigitalInputOutputSubunit)_dioCard.OutputSubunits[portIndex];

            subunit[bitIndex+1] = state != 0;
         }
      }

      /// <summary>
      /// 
      /// </summary>
      /// <param name="signalName"></param>
      /// <returns></returns>
      public IODatatypes.BitState GetBitState(string signalName)
		{
			lock (_syncObj)
			{
            if (!_signalNameToChannelMap.ContainsKey(signalName))
               throw new Exception($"Signal name {signalName} doesn't exist for card: " + _name);

            if (_signalNameToChannelMap[signalName].channelNumber >= _numInputChannels || _signalNameToChannelMap[signalName].channelNumber < _channelStartIndex)
            {
               throw new Exception($"The input channel number {_signalNameToChannelMap[signalName].channelNumber} specified must be >= {_channelStartIndex} and < {_numInputChannels+_channelStartIndex} on card " + _name);
            }

            GetPortIndexAndBitIndex(signalName, out int portIndex, out int bitIndex);

            DigitalInputOutputSubunit subunit = (DigitalInputOutputSubunit)_dioCard.InputSubunits[portIndex];

				return (IODatatypes.BitState)(subunit[bitIndex+1] ? 1:0);
         }
		}

      /// <summary>
      /// Because the user has to define each channel number in the config file, some people will use 0 or 1 start their starting channel number 
		/// Whether the user prefers 0 or 1 as their starting channel number, this function will then calculate the port index and bit index that the
		/// driver API needs to be able to drive/read the signal
		/// <param name="signalName"></param>
		/// <param name="portIndex">portIndex will range from 0..N</param>
		/// <param name="bitIndex">bitIndex will range from 0..M</param>
      /// </summary>
      private void GetPortIndexAndBitIndex(string signalName, out int portIndex, out int bitIndex)
      {
         portIndex = (int)(Math.Ceiling((double)((int)_signalNameToChannelMap[signalName].channelNumber + Math.Abs(_channelStartIndex - 1)) / (double)_numChannelPerPort) - 1.0);

         int multiplier = ((int)_signalNameToChannelMap[signalName].channelNumber + _numChannelPerPort) / _numChannelPerPort;
         bitIndex = (((int)_signalNameToChannelMap[signalName].channelNumber + _numChannelPerPort) - (_numChannelPerPort * multiplier)) - _channelStartIndex;
         if (bitIndex < 0)
         {
            bitIndex = _numChannelPerPort - 1;
         }
      }

      /// <summary>
      /// 
      /// </summary>
      public InstrumentMetadata Info
		{
			get
			{
				throw new NotImplementedException();
			}
		}

		/// <summary>
		/// 
		/// </summary>
		public string Name
		{
			get { return _name; }
			set { _name = value; }
		}

		/// <summary>
		/// 
		/// </summary>
		public uint NumberOfInputBits
		{
			get
			{
				return (uint)_numInputChannels;
			}
		}

		/// <summary>
		/// 
		/// </summary>
		public uint NumberOfOutputBits
		{
			get
			{
				return (uint)_numOutputChannels;
			}
		}

		/// <summary>
		/// 
		/// </summary>
		/// <returns></returns>
		public SelfTestResult PerformSelfTest()
		{
			lock (_syncObj)
			{
            throw new NotImplementedException();
         }
		}

		/// <summary>
		/// 
		/// </summary>
		public void Reset()
		{
			lock (_syncObj)
			{
            Shutdown();
            Initialize();
         }
		}

		/// <summary>
		/// 
		/// </summary>
		public SelfTestResult SelfTestResult
		{
			get
			{
				return _selfTestResult;
			}
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="bit"></param>
		public void SetTristate(string signalName)
		{
         throw new NotImplementedException();
      }

		/// <summary>
		/// 
		/// </summary>
		public State Status
		{
			get
			{
				return _state;
			}
		}

		/// <summary>
		/// 
		/// </summary>
		public void Shutdown()
		{
			lock (_syncObj)
			{
				_state = State.Uninitialized;
			}
		}
		#endregion
	}
}
